import ctypes
from ctypes import c_bool, c_void_p, c_int, c_byte, c_char_p, c_ulong, c_ushort, POINTER, c_uint, c_char, c_float, c_short, c_wchar_p, c_ubyte, c_long
# c_uchar, c_handle <-沒有這兩個ctype??

pac_api = ctypes.CDLL('.\PACSDK.dll')

#=========================================================================
#  01. System Information API
#=========================================================================
PAC_PARALLEL = 0x80
PAC_PARALLEL_RW = 0x81
PAC_SCAN = 0x40
PAC_DI32 = 0xE3
PAC_32BIT = 0x20
PAC_DO32 = 0xE0
PAC_DI16DO16 = 0xE2
PAC_DI16 = 0xC3
PAC_DO16 = 0xC0
PAC_DI8DO8 = 0xC2
PAC_8K = 8000
PAC_9K = 9000

def PAC_EBUS_SLOT(iSlot):
    return 0x80 | iSlot

pac_api.pac_SetMemoryMapping.restype = None

pac_api.pac_BackwardCompatible.restype = c_bool

pac_api.pac_ChangeSlot.argtypes = [c_byte]
pac_api.pac_ChangeSlot.restype = None

pac_api.pac_CheckSDKVersion.argtypes = [c_ulong]
pac_api.pac_CheckSDKVersion.restype = c_bool

pac_api.pac_EnableLED.argtypes = [c_bool]
pac_api.pac_EnableLED.restype = None

pac_api.pac_EnableLEDs.argtypes = [c_int, c_bool]
pac_api.pac_EnableLEDs.restype = None

pac_api.pac_GetComMapping.argtypes = [c_int]
pac_api.pac_GetComMapping.restype = c_int

pac_api.pac_GetCPUVersion.argtypes = [c_char_p]
pac_api.pac_GetCPUVersion.restype = None

pac_api.pac_ModuleExists.argtypes = [c_void_p, c_int]
pac_api.pac_ModuleExists.restype = c_bool

pac_api.pac_GetModuleName.argtypes = [c_byte, c_char_p]
pac_api.pac_GetModuleName.restype = c_int

pac_api.pac_GetModuleType.argtypes = [c_byte]
pac_api.pac_GetModuleType.restype = c_int

pac_api.pac_GetModuleVersion.argtypes = [c_byte, c_char_p]
pac_api.pac_GetModuleVersion.restype = c_int

pac_api.pac_GetOSVersion.argtypes = [c_char_p]
pac_api.pac_GetOSVersion.restype = None

pac_api.pac_GetRotaryID.restype = c_int

pac_api.pac_GetSDKVersion.argtypes = [c_char_p]
pac_api.pac_GetSDKVersion.restype = None

pac_api.pac_GetSerialNumber.argtypes = [c_char_p]
pac_api.pac_GetSerialNumber.restype = None

#pac_api.pac_GetHWID.argtypes = [c_char_p]
#pac_api.pac_GetHWID.restype = None

#pac_api.pac_IsPAC.restype = c_bool

#=========================================================================
# 02. Backplane API
#=========================================================================
pac_api.pac_EnableRetrigger.argtypes = [c_byte]
pac_api.pac_EnableRetrigger.restype = None

pac_api.pac_GetBackplaneID.argtypes = [c_char_p]
pac_api.pac_GetBackplaneID.restype = None

pac_api.pac_GetBatteryLevel.argtypes = [c_int]
pac_api.pac_GetBatteryLevel.restype = c_int

pac_api.pac_GetDIPSwitch.restype = c_int

pac_api.pac_GetSlotCount.restype = c_int

#pac_api.pac_RegistryHotPlug.argtypes = [c_ulong, c_ulong]
#pac_api.pac_RegistryHotPlug.restype = None

#pac_api.pac_UnregistryHotPlug.argtypes = [c_ulong]
#pac_api.pac_UnregistryHotPlug.restype = None

pac_api.pac_GetBoardNoByEBusSlot.argtypes = [POINTER(c_ushort), POINTER(c_ulong), c_ushort]
pac_api.pac_GetBoardNoByEBusSlot.restype = c_bool

#pac_api.pac_GetModuleInfoByEbus.argtypes = [c_ushort, c_ushort, POINTER(c_ushort), POINTER(c_ushort), POINTER(c_ushort), POINTER(c_ushort), POINTER(c_uchar), POINTER(c_uchar), POINTER(c_uchar), POINTER(c_uchar)]
#pac_api.pac_GetModuleInfoByEbus.restype = c_bool

#pac_api.pac_ClearHotPlug.restype = None

pac_api.pac_ClearRisingEdgeIRQ.argtypes = [c_byte]
pac_api.pac_ClearRisingEdgeIRQ.restype = None

#pac_api.pac_EnableHotPlug.argtypes = [c_bool]
#pac_api.pac_EnableHotPlug.restype = None

pac_api.pac_EnableRisingEdgeIRQ.argtypes = [c_byte, c_bool]
pac_api.pac_EnableRisingEdgeIRQ.restype = None

pac_api.pac_EOI.restype = None

#pac_api.pac_GetHotPlugIRQState.restype = c_bool

#pac_api.pac_GetHotPlugStatus.restype = c_bool

pac_api.pac_GetRisingEdgeEnableStatus.restype = c_byte

pac_api.pac_GetRisingEdgeIRQStatus.restype = c_byte

pac_api.pac_ResetBackplane.restype = None

pac_api.pac_ResetSystemToDefault.restype = None

#=========================================================================
# 03. Interrupt API
#=========================================================================
PAC_INTR_DONE = 0
PAC_INTR_DONE1 = 1
PAC_INTR_FAIL = 2
PAC_INTR_EXIT = 3

INTR_RISING_TRIG = 0
INTR_LEVEL_TRIG = 1
INTR_FALLING_TRIG = 2

PAC_CALLBACK_FUNC = ctypes.WINFUNCTYPE(c_int)

pac_api.pac_EnableSlotInterrupt.argtypes = [c_byte, c_bool]
pac_api.pac_EnableSlotInterrupt.restype = None

#pac_api.pac_GetSlotInterruptEvent.argtypes = [c_byte]
#pac_api.pac_GetSlotInterruptEvent.restype = c_handle

pac_api.pac_GetSlotInterruptID.argtypes = [c_byte]
pac_api.pac_GetSlotInterruptID.restype = c_ulong

pac_api.pac_InterruptDone.argtypes = [c_byte]
pac_api.pac_InterruptDone.restype = None

pac_api.pac_InterruptInitialize.argtypes = [c_byte]
pac_api.pac_InterruptInitialize.restype = c_bool

pac_api.pac_RegisterSlotInterrupt.argtypes = [c_byte, PAC_CALLBACK_FUNC]
pac_api.pac_RegisterSlotInterrupt.restype = c_bool

#pac_api.pac_SetSlotInterruptEvent.argtypes = [c_byte, c_handle]
#pac_api.pac_SetSlotInterruptEvent.restype = None

pac_api.pac_SetSlotInterruptPriority.argtypes = [c_byte, c_int]
pac_api.pac_SetSlotInterruptPriority.restype = c_bool

pac_api.pac_SetTriggerType.argtypes = [c_byte, c_int]
pac_api.pac_SetTriggerType.restype = None

pac_api.pac_UnregisterSlotInterrupt.argtypes = [c_byte]
pac_api.pac_UnregisterSlotInterrupt.restype = c_bool

#=========================================================================
# 04. Memory Access API
#=========================================================================
PAC_MEM_SRAM = 0
PAC_MEM_EEPROM = 1
PAC_MEM_NVRAM = 2

pac_api.pac_GetMemorySize.argtypes = [c_int]
pac_api.pac_GetMemorySize.restype = c_ulong

pac_api.pac_ReadMemory.argtypes = [c_ulong, POINTER(c_byte), c_ulong, c_int]
pac_api.pac_ReadMemory.restype = c_bool

pac_api.pac_WriteMemory.argtypes = [c_ulong, POINTER(c_byte), c_ulong, c_int]
pac_api.pac_WriteMemory.restype = c_bool

pac_api.pac_EnableEEPROM.argtypes = [c_bool]
pac_api.pac_EnableEEPROM.restype = None

#=========================================================================
# 05. Watchdog API
#=========================================================================
PAC_WDT_HW = 0
PAC_WDT_OS = 1
pac_api.pac_DisableWatchDog.argtypes = [c_int]
pac_api.pac_DisableWatchDog.restype = None

pac_api.pac_EnableWatchDog.argtypes = [c_int, c_ulong]
pac_api.pac_EnableWatchDog.restype = c_bool

pac_api.pac_GetWatchDogState.argtypes = [c_int]
pac_api.pac_GetWatchDogState.restype = c_bool

pac_api.pac_GetWatchDogTime.argtypes = [c_int]
pac_api.pac_GetWatchDogTime.restype = c_ulong

pac_api.pac_RefreshWatchDog.argtypes = [c_int]
pac_api.pac_RefreshWatchDog.restype = None

pac_api.pac_SetWatchDogTime.argtypes = [c_int, c_ulong]
pac_api.pac_SetWatchDogTime.restype = c_bool

#=========================================================================
# 06. microSD Management API (WinPAC only)
#=========================================================================
#pac_api.pac_SDExists.argtypes = []
#pac_api.pac_SDExists.restype = c_bool

#pac_api.pac_SDMount.argtypes = [ctypes.c_wchar_p]
#pac_api.pac_SDMount.restype = c_bool

#pac_api.pac_SDOnside.argtypes = []
#pac_api.pac_SDOnside.restype = c_bool

#pac_api.pac_SDUnmount.argtypes = []
#pac_api.pac_SDUnmount.restype = c_bool

#=========================================================================
# 07. Registry API
#=========================================================================
PKT_NONE = 0
PKT_KEY = 1
PKT_STRING = 2
PKT_DWORD = 3

pac_api.pac_RegCountKey.argtypes = [c_char_p]
pac_api.pac_RegCountKey.restype = c_ulong

pac_api.pac_RegCountValue.argtypes = [c_char_p]
pac_api.pac_RegCountValue.restype = c_ulong

pac_api.pac_RegCreateKey.argtypes = [c_char_p]
pac_api.pac_RegCreateKey.restype = c_bool

pac_api.pac_RegDeleteKey.argtypes = [c_char_p]
pac_api.pac_RegDeleteKey.restype = c_bool

pac_api.pac_RegDeleteValue.argtypes = [c_char_p]
pac_api.pac_RegDeleteValue.restype = c_bool

pac_api.pac_RegGetDWORD.argtypes = [c_char_p]
pac_api.pac_RegGetDWORD.restype = c_ulong

pac_api.pac_RegGetKeyByIndex.argtypes = [c_char_p, c_ulong, POINTER(c_char)]
pac_api.pac_RegGetKeyByIndex.restype = c_bool

pac_api.pac_RegGetKeyInfo.argtypes = [c_char_p]
pac_api.pac_RegGetKeyInfo.restype = c_ulong

pac_api.pac_RegGetString.argtypes = [c_char_p, POINTER(c_char), c_ulong]
pac_api.pac_RegGetString.restype = c_bool

pac_api.pac_RegGetValueByIndex.argtypes = [c_char_p, c_ulong, POINTER(c_char)]
pac_api.pac_RegGetValueByIndex.restype = c_bool

pac_api.pac_RegKeyExist.argtypes = [c_char_p]
pac_api.pac_RegKeyExist.restype = c_bool

pac_api.pac_RegSave.argtypes = [c_char_p]
pac_api.pac_RegSave.restype = c_bool

pac_api.pac_RegSetString.argtypes = [c_char_p, c_char_p, c_ulong]
pac_api.pac_RegSetString.restype = c_bool

pac_api.pac_RegSetDWORD.argtypes = [c_char_p, c_ulong]
pac_api.pac_RegSetDWORD.restype = c_bool

#=========================================================================
# 08. UART API
#=========================================================================
CTO_TIMEOUT_ALL = 0
CTO_READ_RETRY_TIMEOUT = 1
CTO_READ_TOTAL_TIMEOUT = 2
CTO_WRITE_TOTAL_TIMEOUT = 3

CTS = 0
DSR = 1
RI = 2
CD = 3

IN_DATA = 0
OUT_DATA = 1


pac_api.uart_Open.argtypes = [c_char_p]
pac_api.uart_Open.restype = c_void_p

pac_api.uart_OpenEx.argtypes = [c_char_p]
pac_api.uart_OpenEx.restype = c_void_p

pac_api.uart_Close.argtypes = [c_void_p]
pac_api.uart_Close.restype = c_bool

pac_api.uart_Write.argtypes = [c_void_p, c_char_p]
pac_api.uart_Write.restype = c_bool

pac_api.uart_Read.argtypes = [c_void_p, POINTER(c_char)]
pac_api.uart_Read.restype = c_bool

pac_api.uart_WriteExt.argtypes = [c_void_p, c_char_p, c_ulong]
pac_api.uart_WriteExt.restype = c_bool

pac_api.uart_ReadExt.argtypes = [c_void_p, POINTER(c_char), c_ulong]
pac_api.uart_ReadExt.restype = c_bool

pac_api.uart_Send.argtypes = [c_void_p, c_char_p]
pac_api.uart_Send.restype = c_bool

pac_api.uart_Recv.argtypes = [c_void_p, POINTER(c_char)]
pac_api.uart_Recv.restype = c_bool

pac_api.uart_SendCmd.argtypes = [c_void_p, c_char_p, POINTER(c_char)]
pac_api.uart_SendCmd.restype = c_bool

pac_api.uart_SendExt.argtypes = [c_void_p, c_char_p, c_ulong]
pac_api.uart_SendExt.restype = c_bool

pac_api.uart_RecvExt.argtypes = [c_void_p, POINTER(c_char), c_ulong]
pac_api.uart_RecvExt.restype = c_bool

pac_api.uart_SendCmdExt.argtypes = [c_void_p, c_char_p, c_ulong, POINTER(c_char), c_ulong]
pac_api.uart_SendCmdExt.restype = c_bool

pac_api.uart_SetTimeOut.argtypes = [c_void_p, c_ulong, c_int]
pac_api.uart_SetTimeOut.restype = None

pac_api.uart_EnableCheckSum.argtypes = [c_void_p, c_bool]
pac_api.uart_EnableCheckSum.restype = None

pac_api.uart_SetTerminator.argtypes = [c_void_p, c_char_p]
pac_api.uart_SetTerminator.restype = None

pac_api.uart_BinSend.argtypes = [c_void_p, c_char_p, c_ulong]
pac_api.uart_BinSend.restype = c_bool

pac_api.uart_BinRecv.argtypes = [c_void_p, POINTER(c_char), c_ulong]
pac_api.uart_BinRecv.restype = c_bool

pac_api.uart_BinSendCmd.argtypes = [c_void_p, c_char_p, c_ulong, POINTER(c_char), c_ulong]
pac_api.uart_BinSendCmd.restype = c_bool

pac_api.uart_GetDataSize.argtypes = [c_void_p, c_int]
pac_api.uart_GetDataSize.restype = c_ulong

pac_api.uart_GetLineStatus.argtypes = [c_void_p, c_int]
pac_api.uart_GetLineStatus.restype = c_bool

pac_api.uart_SetLineStatus.argtypes = [c_void_p, c_int, c_int]
pac_api.uart_SetLineStatus.restype = c_ulong

pac_api.uart_GetOutputLineStatus.argtypes = [c_void_p]
pac_api.uart_GetOutputLineStatus.restype = c_ulong

pac_api.uart_ChangeMode.argtypes = [c_int]
pac_api.uart_ChangeMode.restype = c_bool

#=========================================================================
# 09. PAC_IO API
#=========================================================================
PAC_REMOTE_IO_BASE = 0x1000
PAC_REMOTE_iPAC_BASE = 0x100000
PAC_DAISY_CHAIN_WIRING_MODULE_PORT_BASE = 0x1000000

def PAC_REMOTE_IO(iAddress):
    return PAC_REMOTE_IO_BASE | iAddress

def PAC_REMOTE_iPAC(iAddr, iSlot):
    return PAC_REMOTE_iPAC_BASE | (iAddr << 8) | iSlot

def PAC_DAISY_CHAIN_WIRING_MODULE_PORT(slot, port):
    if slot & PAC_REMOTE_IO_BASE:
        return PAC_DAISY_CHAIN_WIRING_MODULE_PORT_BASE | ((slot & 0xFFF) << 8) | port | (0x1 << 6)
    elif slot & PAC_REMOTE_iPAC_BASE:
        return PAC_DAISY_CHAIN_WIRING_MODULE_PORT_BASE | ((slot & 0xFFFFF) << 8) | port | (0x2 << 6)
    else:
        return PAC_DAISY_CHAIN_WIRING_MODULE_PORT_BASE | (slot << 8) | port

def pac_GetBit(v, ndx):
    return v & (1 << ndx)

pac_api.pac_WriteDO.argtypes = [c_void_p, c_int, c_int, c_ulong]
pac_api.pac_WriteDO.restype = c_bool

pac_api.pac_WriteDOBit.argtypes = [c_void_p, c_int, c_int, c_int, c_int]
pac_api.pac_WriteDOBit.restype = c_bool

pac_api.pac_ReadDO.argtypes = [c_void_p, c_int, c_int, POINTER(c_ulong)]
pac_api.pac_ReadDO.restype = c_bool

pac_api.pac_ReadDI.argtypes = [c_void_p, c_int, c_int, POINTER(c_ulong)]
pac_api.pac_ReadDI.restype = c_bool

pac_api.pac_ReadDIO.argtypes = [c_void_p, c_int, c_int, c_int, POINTER(c_ulong), POINTER(c_ulong)]
pac_api.pac_ReadDIO.restype = c_bool

pac_api.pac_ReadDILatch.argtypes = [c_void_p, c_int, c_int, c_int, POINTER(c_ulong)]
pac_api.pac_ReadDILatch.restype = c_bool

pac_api.pac_ClearDILatch.argtypes = [c_void_p, c_int]
pac_api.pac_ClearDILatch.restype = c_bool

pac_api.pac_ReadDIOLatch.argtypes = [c_void_p, c_int, c_int, c_int, c_int, POINTER(c_ulong), POINTER(c_ulong)]
pac_api.pac_ReadDIOLatch.restype = c_bool

pac_api.pac_ClearDIOLatch.argtypes = [c_void_p, c_int]
pac_api.pac_ClearDIOLatch.restype = c_bool

pac_api.pac_ReadDICNT.argtypes = [c_void_p, c_int, c_int, c_int, POINTER(c_ulong)]
pac_api.pac_ReadDICNT.restype = c_bool

pac_api.pac_ClearDICNT.argtypes = [c_void_p, c_int, c_int, c_int]
pac_api.pac_ClearDICNT.restype = c_bool

pac_api.pac_WriteAO.argtypes = [c_void_p, c_int, c_int, c_int, c_float]
pac_api.pac_WriteAO.restype = c_bool

pac_api.pac_ReadAO.argtypes = [c_void_p, c_int, c_int, c_int, POINTER(c_float)]
pac_api.pac_ReadAO.restype = c_bool

pac_api.pac_ReadAI.argtypes = [c_void_p, c_int, c_int, c_int, POINTER(c_float)]
pac_api.pac_ReadAI.restype = c_bool

pac_api.pac_ReadAIHex.argtypes = [c_void_p, c_int, c_int, c_int, POINTER(c_int)]
pac_api.pac_ReadAIHex.restype = c_bool

pac_api.pac_ReadAIAll.argtypes = [c_void_p, c_int, POINTER(c_float)]
pac_api.pac_ReadAIAll.restype = c_bool

pac_api.pac_ReadAIAllHex.argtypes = [c_void_p, c_int, POINTER(c_int)]
pac_api.pac_ReadAIAllHex.restype = c_bool

pac_api.pac_ReadCNT.argtypes = [c_void_p, c_int, c_int, POINTER(c_ulong)]
pac_api.pac_ReadCNT.restype = c_bool

pac_api.pac_ClearCNT.argtypes = [c_void_p, c_int, c_int]
pac_api.pac_ClearCNT.restype = c_bool

pac_api.pac_ReadCNTOverflow.argtypes = [c_void_p, c_int, c_int, POINTER(c_int)]
pac_api.pac_ReadCNTOverflow.restype = c_bool

pac_api.pac_ReadCNTAll.argtypes = [c_void_p, c_int, c_int, POINTER(c_ulong)]
pac_api.pac_ReadCNTAll.restype = c_bool

pac_api.pac_ClearCNTAll.argtypes = [c_void_p, c_int, c_int]
pac_api.pac_ClearCNTAll.restype = c_bool

pac_api.pac_ReadFREQ.argtypes = [c_void_p, c_int, c_int, POINTER(c_float)]
pac_api.pac_ReadFREQ.restype = c_bool

pac_api.pac_GetModuleLastOutputSource.argtypes = [c_void_p, c_int]
pac_api.pac_GetModuleLastOutputSource.restype = c_short

pac_api.pac_GetModuleWDTStatus.argtypes = [c_void_p, c_int]
pac_api.pac_GetModuleWDTStatus.restype = c_bool

pac_api.pac_GetModuleWDTStatusEX.argtypes = [c_void_p, c_int, POINTER(c_short)]
pac_api.pac_GetModuleWDTStatusEX.restype = c_bool

pac_api.pac_GetModuleWDTConfig.argtypes = [c_void_p, c_int, POINTER(c_short), POINTER(c_ulong), POINTER(c_int)]
pac_api.pac_GetModuleWDTConfig.restype = c_bool

pac_api.pac_SetModuleWDTConfig.argtypes = [c_void_p, c_int, c_short, c_ulong, c_int]
pac_api.pac_SetModuleWDTConfig.restype = c_bool

pac_api.pac_ResetModuleWDT.argtypes = [c_void_p, c_int]
pac_api.pac_ResetModuleWDT.restype = c_bool

pac_api.pac_RefreshModuleWDT.argtypes = [c_void_p, c_int]
pac_api.pac_RefreshModuleWDT.restype = c_bool

pac_api.pac_InitModuleWDTInterrupt.argtypes = [c_int, ctypes.CFUNCTYPE(None)]
pac_api.pac_InitModuleWDTInterrupt.restype = c_bool

pac_api.pac_SetModuleWDTInterruptStatus.argtypes = [c_int, c_short]
pac_api.pac_SetModuleWDTInterruptStatus.restype = c_bool

pac_api.pac_GetModuleWDTInterruptStatus.argtypes = [c_int]
pac_api.pac_GetModuleWDTInterruptStatus.restype = c_short

pac_api.pac_ReadModuleSafeValueDO.argtypes = [c_void_p, c_int, c_int, POINTER(c_ulong)]
pac_api.pac_ReadModuleSafeValueDO.restype = c_bool

pac_api.pac_WriteModuleSafeValueDO.argtypes = [c_void_p, c_int, c_int, c_ulong]
pac_api.pac_WriteModuleSafeValueDO.restype = c_bool

pac_api.pac_ReadModuleSafeValueAO.argtypes = [c_void_p, c_int, c_int, c_int, POINTER(c_float)]
pac_api.pac_ReadModuleSafeValueAO.restype = c_bool

pac_api.pac_WriteModuleSafeValueAO.argtypes = [c_void_p, c_int, c_int, c_int, c_float]
pac_api.pac_WriteModuleSafeValueAO.restype = c_bool

pac_api.pac_ReadModulePowerOnValueDO.argtypes = [c_void_p, c_int, c_int, POINTER(c_ulong)]
pac_api.pac_ReadModulePowerOnValueDO.restype = c_bool

pac_api.pac_WriteModulePowerOnValueDO.argtypes = [c_void_p, c_int, c_int, c_ulong]
pac_api.pac_WriteModulePowerOnValueDO.restype = c_bool

pac_api.pac_ReadModulePowerOnValueAO.argtypes = [c_void_p, c_int, c_int, c_int, POINTER(c_float)]
pac_api.pac_ReadModulePowerOnValueAO.restype = c_bool

pac_api.pac_WriteModulePowerOnValueAO.argtypes = [c_void_p, c_int, c_int, c_int, c_float]
pac_api.pac_WriteModulePowerOnValueAO.restype = c_bool

#=========================================================================
# 10. Backplane timer API
#=========================================================================
TIMEROUT = 2
TIMER1 = 0
TIMER2 = 1

PAC_TIMEROUT_CALLBACK_FUNC = ctypes.CFUNCTYPE(c_int)

pac_api.pac_GetBPTimerTimeTick_ms.argtypes = []
pac_api.pac_GetBPTimerTimeTick_ms.restype = c_ulong

pac_api.pac_GetBPTimerTimeTick_us.argtypes = []
pac_api.pac_GetBPTimerTimeTick_us.restype = c_ushort

pac_api.pac_KillBPTimer.argtypes = [c_int]
pac_api.pac_KillBPTimer.restype = None

pac_api.pac_SetBPTimer.argtypes = [c_int, c_uint, PAC_TIMEROUT_CALLBACK_FUNC]
pac_api.pac_SetBPTimer.restype = c_bool

pac_api.pac_SetBPTimerInterruptPriority.argtypes = [c_int, c_int]
pac_api.pac_SetBPTimerInterruptPriority.restype = c_bool

pac_api.pac_SetBPTimerOut.argtypes = [c_uint, c_uint, PAC_TIMEROUT_CALLBACK_FUNC]
pac_api.pac_SetBPTimerOut.restype = c_bool

#=========================================================================
#  11. Error Handling API
#=========================================================================
pac_api.pac_ClearLastError.argtypes = [c_ulong]
pac_api.pac_ClearLastError.restype = None

pac_api.pac_GetLastError.argtypes = []
pac_api.pac_GetLastError.restype = c_ulong

pac_api.pac_SetLastError.argtypes = [c_ulong]
pac_api.pac_SetLastError.restype = None

pac_api.pac_GetErrorMessage.argtypes = [c_ulong, c_wchar_p]
pac_api.pac_GetErrorMessage.restype = None

#=========================================================================
# 12. MISC API
#=========================================================================
pac_api.pac_AnsiToWideString.argtypes = [c_char_p, c_wchar_p]
pac_api.pac_AnsiToWideString.restype = None

pac_api.pac_DoEvent.argtypes = []
pac_api.pac_DoEvent.restype = None

pac_api.pac_DoEvents.argtypes = []
pac_api.pac_DoEvents.restype = None

#pac_api.pac_WideStringToAnsi.argtypes = [c_wchar_p, c_char_p]
#pac_api.pac_WideStringToAnsi.restype = None

pac_api.pac_WideToAnsiString.argtypes = [c_wchar_p, c_char_p]
pac_api.pac_WideToAnsiString.restype = None

pac_api.pac_GetCurrentDirectory.argtypes = [c_char_p, c_uint]
pac_api.pac_GetCurrentDirectory.restype = c_int

pac_api.pac_GetCurrentDirectoryW.argtypes = [c_wchar_p, c_uint]
pac_api.pac_GetCurrentDirectoryW.restype = c_int

#=========================================================================
# 13. Buzzer API (undoc)
#=========================================================================
pac_api.pac_BuzzerBeep.argtypes = [c_int, c_uint]
pac_api.pac_BuzzerBeep.restype = None

pac_api.pac_GetBuzzerFreqDuty.argtypes = [ctypes.POINTER(c_int), ctypes.POINTER(c_int)]
pac_api.pac_GetBuzzerFreqDuty.restype = None

pac_api.pac_SetBuzzerFreqDuty.argtypes = [c_int, c_int]
pac_api.pac_SetBuzzerFreqDuty.restype = None

pac_api.pac_StopBuzzer.argtypes = []
pac_api.pac_StopBuzzer.restype = None

#====================
#PWM
#===================
pac_api.pac_SetPWMDuty.argtypes = [c_void_p, c_int, c_short, c_float]
pac_api.pac_SetPWMDuty.restype = c_bool

pac_api.pac_GetPWMDuty.argtypes = [c_void_p, c_int, c_short, ctypes.POINTER(c_float)]
pac_api.pac_GetPWMDuty.restype = c_bool

pac_api.pac_SetPWMFrequency.argtypes = [c_void_p, c_int, c_short, c_ulong]
pac_api.pac_SetPWMFrequency.restype = c_bool

pac_api.pac_GetPWMFrequency.argtypes = [c_void_p, c_int, c_short, ctypes.POINTER(c_ulong)]
pac_api.pac_GetPWMFrequency.restype = c_bool

pac_api.pac_SetPWMMode.argtypes = [c_void_p, c_int, c_short, c_long]
pac_api.pac_SetPWMMode.restype = c_bool

pac_api.pac_GetPWMMode.argtypes = [c_void_p, c_int, c_short, ctypes.POINTER(c_long)]
pac_api.pac_GetPWMMode.restype = c_bool

pac_api.pac_SetPWMDITriggerConfig.argtypes = [c_void_p, c_int, c_short, c_short]
pac_api.pac_SetPWMDITriggerConfig.restype = c_bool

pac_api.pac_GetPWMDITriggerConfig.argtypes = [c_void_p, c_int, c_short, ctypes.POINTER(c_short)]
pac_api.pac_GetPWMDITriggerConfig.restype = c_bool

pac_api.pac_SetPWMStart.argtypes = [c_void_p, c_int, c_short]
pac_api.pac_SetPWMStart.restype = c_bool

pac_api.pac_SetPWMSynChannel.argtypes = [c_void_p, c_int, c_short, c_short]
pac_api.pac_SetPWMSynChannel.restype = c_bool

pac_api.pac_GetPWMSynChannel.argtypes = [c_void_p, c_int, c_short, ctypes.POINTER(c_short)]
pac_api.pac_GetPWMSynChannel.restype = c_bool

pac_api.pac_SyncPWMStart.argtypes = [c_void_p, c_int, c_short]
pac_api.pac_SyncPWMStart.restype = c_bool

pac_api.pac_SavePWMConfig.argtypes = [c_void_p, c_int]
pac_api.pac_SavePWMConfig.restype = c_bool

pac_api.pac_GetPWMDIOStatus.argtypes = [c_void_p, c_int, ctypes.POINTER(c_ubyte), ctypes.POINTER(c_ubyte)]
pac_api.pac_GetPWMDIOStatus.restype = c_bool

pac_api.pac_SetPWMPulseCount.argtypes = [c_void_p, c_int, c_short, c_long]
pac_api.pac_SetPWMPulseCount.restype = c_bool

pac_api.pac_GetPWMPulseCount.argtypes = [c_void_p, c_int, c_short, ctypes.POINTER(c_long)]
pac_api.pac_GetPWMPulseCount.restype = c_bool

#=========================================================================
# 15. FAN API
#=========================================================================
PAC_FAN_CPU = 0
PAC_FAN_SPEED_CONTROL_MODE = 0
PAC_FAN_THERMAL_CRUISE_MODE = 1

pac_api.pac_GetFanValue.argtypes = [c_int, ctypes.POINTER(c_int), ctypes.POINTER(c_int), ctypes.POINTER(c_int)]
pac_api.pac_GetFanValue.restype = c_int

pac_api.pac_SetFanValue.argtypes = [c_int, c_int, c_int, c_int]
pac_api.pac_SetFanValue.restype = c_int

pac_api.pac_GetFanSpeed.argtypes = [c_int, ctypes.POINTER(c_int)]
pac_api.pac_GetFanSpeed.restype = c_bool

#=========================================================================
# 16. SMbus API
#=========================================================================
pac_api.pac_SMBus_Open.argtypes = [c_char_p]
pac_api.pac_SMBus_Open.restype = ctypes.c_void_p

pac_api.pac_SMBus_Close.argtypes = [ctypes.c_void_p]
pac_api.pac_SMBus_Close.restype = c_bool

pac_api.pac_SMBus_Read_Byte.argtypes = [ctypes.c_void_p, c_int, c_ubyte, ctypes.POINTER(c_ubyte)]
pac_api.pac_SMBus_Read_Byte.restype = c_bool

pac_api.pac_SMBus_Write_Byte.argtypes = [ctypes.c_void_p, c_int, c_ubyte, c_uint]
pac_api.pac_SMBus_Write_Byte.restype = c_bool

pac_api.pac_SMBus_ProcessCall.argtypes = [ctypes.c_void_p, c_int, c_ubyte, ctypes.POINTER(c_uint), ctypes.POINTER(c_uint)]
pac_api.pac_SMBus_ProcessCall.restype = c_bool

pac_api.pac_SMBus_Block_Read.argtypes = [ctypes.c_void_p, c_int, c_ubyte, c_int, ctypes.POINTER(c_uint)]
pac_api.pac_SMBus_Block_Read.restype = c_bool

pac_api.pac_SMBus_Block_Write.argtypes = [ctypes.c_void_p, c_int, c_ubyte, c_int, ctypes.POINTER(c_uint)]
pac_api.pac_SMBus_Block_Write.restype = c_bool

#=========================================================================
# Undocumented API
#=========================================================================
pac_api._pac_inp.argtypes = [c_uint]
pac_api._pac_inp.restype = c_byte

pac_api._pac_outp.argtypes = [c_uint, c_byte]
pac_api._pac_outp.restype = None

pac_api._pac_map.argtypes = [c_uint]
pac_api._pac_map.restype = POINTER(c_byte)

pac_api._pac_slot_inp.argtypes = [c_byte, c_uint]
pac_api._pac_slot_inp.restype = c_byte

pac_api._pac_slot_outp.argtypes = [c_byte, c_uint, c_byte]
pac_api._pac_slot_outp.restype = None

pac_api._pac_slot_map.argtypes = [c_byte, c_uint]
pac_api._pac_slot_map.restype = POINTER(c_byte)

pac_api._pac_get_slot_offset.argtypes = [c_byte]
pac_api._pac_get_slot_offset.restype = c_ulong

pac_api._pac_get_base_address.argtypes = []
pac_api._pac_get_base_address.restype = POINTER(c_byte)

pac_api._pac_inpw.argtypes = [c_uint]
pac_api._pac_inpw.restype = c_ushort

pac_api._pac_outpw.argtypes = [c_uint, c_ushort]
pac_api._pac_outpw.restype = None

pac_api._pac_slot_inpw.argtypes = [c_byte, c_uint]
pac_api._pac_slot_inpw.restype = c_ushort

pac_api._pac_slot_outpw.argtypes = [c_byte, c_uint, c_ushort]
pac_api._pac_slot_outpw.restype = None

#pac_api._pac_refresh_screen.argtypes = []
#pac_api._pac_refresh_screen.restype = None

pac_api._pac_us_delay.argtypes = [c_ulong]
pac_api._pac_us_delay.restype = None

pac_api._pac_ms_delay.argtypes = [c_ulong]
pac_api._pac_ms_delay.restype = None

pac_api._pac_ticks_delay.argtypes = [c_ulong]
pac_api._pac_ticks_delay.restype = None

#pac_api._pac_get_partition_info.argtypes = [c_char_p, c_char_p, c_char_p]
#pac_api._pac_get_partition_info.restype = c_bool

pac_api._pac_oscr0.argtypes = []
pac_api._pac_oscr0.restype = c_ulong

pac_api._pac_delay.argtypes = [c_ushort]
pac_api._pac_delay.restype = c_float

pac_api._pac_slot_addr.argtypes = [c_byte, c_uint]
pac_api._pac_slot_addr.restype = c_ulong

pac_api._pac_get_CPUtype.argtypes = []
pac_api._pac_get_CPUtype.restype = c_ushort

pac_api._pac_get_HWID.argtypes = []
pac_api._pac_get_HWID.restype = c_ushort

pac_api.__PAC_SLOT_ADDR.argtypes = [c_byte, c_uint]
pac_api.__PAC_SLOT_ADDR.restype = c_ulong

pac_api.__PAC_SLOT_OFFSET.argtypes = [c_byte]
pac_api.__PAC_SLOT_OFFSET.restype = c_ulong

pac_api.pac_read_pci_byte.argtypes = [c_byte, c_byte, c_byte, c_ulong, POINTER(c_byte)]
pac_api.pac_read_pci_byte.restype = c_bool

pac_api.pac_read_pci_word.argtypes = [c_byte, c_byte, c_byte, c_ulong, POINTER(c_ushort)]
pac_api.pac_read_pci_word.restype = c_bool

pac_api.pac_read_pci_dword.argtypes = [c_byte, c_byte, c_byte, c_ulong, POINTER(c_ulong)]
pac_api.pac_read_pci_dword.restype = c_bool

pac_api.pac_write_pci_byte.argtypes = [c_byte, c_byte, c_byte, c_ulong, c_byte]
pac_api.pac_write_pci_byte.restype = c_ushort

pac_api.pac_write_pci_word.argtypes = [c_byte, c_byte, c_byte, c_ulong, c_ushort]
pac_api.pac_write_pci_word.restype = c_ushort

pac_api.pac_write_pci_dword.argtypes = [c_byte, c_byte, c_byte, c_ulong, c_ulong]
pac_api.pac_write_pci_dword.restype = c_ushort

pac_api.pac_ReadPhyMemory_dword.argtypes = [c_int, POINTER(c_ulong)]
pac_api.pac_ReadPhyMemory_dword.restype = c_bool

pac_api.pac_WritePhyMemory_dword.argtypes = [c_int, c_ulong]
pac_api.pac_WritePhyMemory_dword.restype = c_bool

pac_api.pac_write_mem_dword.argtypes = [c_ulong, c_ulong]
pac_api.pac_write_mem_dword.restype = c_bool

pac_api.pac_read_mem_dword.argtypes = [c_ulong, POINTER(c_ulong)]
pac_api.pac_read_mem_dword.restype = c_bool

#=========================================================================
# Error Codes
#=========================================================================
PAC_ERR_SUCCESS = 0x00000
PAC_ERR_UNKNOWN = 0x00001

#Basic=====================================================================
PAC_ERR_BASE = 65536
PAC_ERR_SLOT_REGISTERED = PAC_ERR_BASE + 1
PAC_ERR_SLOT_NOT_REGISTERED = PAC_ERR_BASE + 2
PAC_ERR_UNKNOWN_MODULE = PAC_ERR_BASE + 3
PAC_ERR_INVALID_MAC = PAC_ERR_BASE + 4
PAC_ERR_INVALID_COMPORT_NUMBER = PAC_ERR_BASE + 5
PAC_ERR_FUNCTION_NOT_SUPPORT = PAC_ERR_BASE + 6
PAC_ERR_MODULE_UNEXISTS = PAC_ERR_BASE + 7
PAC_ERR_INVALID_SLOT_NUMBER = PAC_ERR_BASE + 8
PAC_ERR_FUNCTION_REPEAT_CALLED = PAC_ERR_BASE + 9
PAC_ERR_INVALID_HANDLE_VALUE = PAC_ERR_BASE + 10
PAC_ERR_DEVICE_IO_CONTROL = PAC_ERR_BASE + 11
PAC_ERR_INVALID_PARAMETER = PAC_ERR_BASE + 12

#Memory Access=============================================================
PAC_ERR_MEMORY_BASE = 0x11000
PAC_ERR_EEP_INVALID_ADDRESS = PAC_ERR_MEMORY_BASE + 1
PAC_ERR_SRAM_INVALID_ADDRESS = PAC_ERR_MEMORY_BASE + 2
PAC_ERR_MEMORY_INVALID_TYPE = PAC_ERR_MEMORY_BASE + 3
PAC_ERR_NVRAM_INVALID_ADDRESS = PAC_ERR_MEMORY_BASE + 4
PAC_ERR_EEP_WRITE_PROTECT = PAC_ERR_MEMORY_BASE + 5
PAC_ERR_EEP_WRITE_FAIL = PAC_ERR_MEMORY_BASE + 6
PAC_ERR_EEP_READ_FAIL = PAC_ERR_MEMORY_BASE + 7
PAC_ERR_MEMORY_INVALID_SIZE = PAC_ERR_MEMORY_BASE + 8

#Watch Dog=================================================================
PAC_ERR_WDT_BASE = 0x12000
PAC_ERR_WDT_INVALID_VALUE = PAC_ERR_WDT_BASE + 1
PAC_ERR_WDT_UNEXIST = PAC_ERR_WDT_BASE + 2
PAC_ERR_WDT_BASE_NOT_SET = PAC_ERR_WDT_BASE + 3
PAC_ERR_WDT_OS_FOR_OS_STARTUP = PAC_ERR_WDT_BASE + 4

#Interrupt=================================================================
PAC_ERR_INTR_BASE = 0x13000
PAC_ERR_INTR_CREATE_EVENT_FAILURE = PAC_ERR_INTR_BASE + 1

#UART======================================================================
PAC_ERR_UART_BASE = 0x14000
PAC_ERR_UART_CHECKSUM = PAC_ERR_UART_BASE + 1
PAC_ERR_UART_READ_TIMEOUT = PAC_ERR_UART_BASE + 2
PAC_ERR_UART_RESPONSE = PAC_ERR_UART_BASE + 3
PAC_ERR_UART_UNDER_INPUT_RANGE = PAC_ERR_UART_BASE + 4
PAC_ERR_UART_EXCEED_INPUT_RANGE = PAC_ERR_UART_BASE + 5
PAC_ERR_UART_OPEN_FAILED = PAC_ERR_UART_BASE + 6
PAC_ERR_UART_GET_COMM_STATUS_ERROR = PAC_ERR_UART_BASE + 7
PAC_ERR_UART_INVALID_VALUE = PAC_ERR_UART_BASE + 8
PAC_ERR_UART_INTERNAL_BUFFER_OVERFLOW = PAC_ERR_UART_BASE + 9

#IO========================================================================
PAC_ERR_IO_BASE = 0x15000
PAC_ERR_IO_NOT_SUPPORT = PAC_ERR_IO_BASE + 1
PAC_ERR_IO_ID = PAC_ERR_IO_BASE + 2
PAC_ERR_IO_SLOT = PAC_ERR_IO_BASE + 3
PAC_ERR_IO_CHANNEL = PAC_ERR_IO_BASE + 4
PAC_ERR_IO_GAIN = PAC_ERR_IO_BASE + 5
PAC_ERR_IO_INT_MODE = PAC_ERR_IO_BASE + 6
PAC_ERR_IO_VALUE_OUT_OF_RANGE = PAC_ERR_IO_BASE + 7
PAC_ERR_IO_CHANNEL_OUT_OF_RANGE = PAC_ERR_IO_BASE + 8
PAC_ERR_IO_DO_CANNOT_OVERWRITE = PAC_ERR_IO_BASE + 10
PAC_ERR_IO_AO_CANNOT_OVERWRITE = PAC_ERR_IO_BASE + 11

#Backplane Timer===========================================================
PAC_ERR_BPTIMER_BASE = 0x16000
PAC_ERR_BPTIMER_REGISTERED = PAC_ERR_BPTIMER_BASE + 1
PAC_ERR_BPTIMER_NOT_REGISTERED = PAC_ERR_BPTIMER_BASE + 2
PAC_ERR_OPEN_TIMER = PAC_ERR_BPTIMER_BASE + 3

#others ===========================================================
PAC_ERR_OTHERS_BASE = 0x20000
PAC_ERR_COMMMUNICATION_TIMEOUT = PAC_ERR_OTHERS_BASE + 1
PAC_ERR_INVALID_STATUS = PAC_ERR_OTHERS_BASE + 2


#測試API
sdk_version = ctypes.create_string_buffer(64)
pac_api.pac_GetSDKVersion(sdk_version)
print("SDK Version:", sdk_version.value.decode())